// EE231002 Lab07. Magic Square
// 108061112, 林靖
// SIZEov. 2, 2019

#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define SIZE 4
#define UNFILLED 0

typedef int BOOL;

int g_count;
int g_array[SIZE][SIZE];
int g_target_sum;
void solve_unfilled_or_print(void);


int main(void)
{
	int i, j;

	for (i = 0; i < SIZE; i++) {
		for (j = 0; j < SIZE; j++) {
			scanf("%d", &g_array[i][j]);
		}
	}
	g_target_sum = SIZE * (SIZE * SIZE + 1) / 2;
	solve_unfilled_or_print();
	printf("Number of solutions found: %d\n", g_count);
	return 0;
}


void solve_unfilled_or_print(void)
{
	BOOL found_unfilled;
	BOOL is_legal;
	int row, column;
	int i, j;
	int guess;
	int sum;

	found_unfilled = FALSE;
	for (row = 0; !found_unfilled && row < SIZE; row++) {
		for (column = 0; !found_unfilled && column < SIZE; column++) {
			if (g_array[row][column] == UNFILLED) {
				found_unfilled = TRUE;
			}
		}
	}
	row--;
	column--;

	if (found_unfilled) {
		for (guess = SIZE * SIZE; guess > 0; guess--) {
			is_legal = TRUE;
			for (i = 0; is_legal && i < SIZE; i++) {
				for (j = 0; is_legal && j < SIZE; j++) {
					if (g_array[i][j] == guess) {
						is_legal = FALSE;
					}
				}
			}
			if (is_legal) {
				g_array[row][column] = guess;
				solve_unfilled_or_print();
				g_array[row][column] = UNFILLED;
			}
		}
	} else {
		is_legal = TRUE;
		if (is_legal) {
			for (i = 0; i < SIZE; i++) {
				sum = 0;
				for (j = 0; j < SIZE; j++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			for (j = 0; j < SIZE; j++) {
				sum = 0;
				for (i = 0; i < SIZE; i++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = 0; i < SIZE; i++, j++) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = SIZE - 1; i < SIZE; i++, j--) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			printf("Solution %d:\n", ++g_count);
			for (i = 0; i < SIZE; i++) {
				for (j = 0; j < SIZE; j++) {
					printf("%4d", g_array[i][j]);
				}
				printf("\n");
			}
			printf("\n");
		}
	}
	return;
}
